EDIT - bug #8132

phycobank cdm-server instance problems with db connections
02/22/2019 06:38 PM - Andreas Kohlbecker

Status: Worksforme Start date:

Priority: Highest Due date:

Assignee: Wolf-Henning Kusber % Done: 0%
Category: cdmserver Estimated time: 0:00 hour
Target version:

Severity: critical Found in Version:

Description

the phycobank cdm-server instance which is running in a docker container got problems with the db connections
Problem accessing /phycobank/registrationDTO/identifier/http%3A%2F%2Fphycobank.org%2F100530.json. Reason:
com.mysql. jdbc.exceptions. jdbc4.CommunicationsException: The last packet successfully received fro
m the server was 89,950,095 milliseconds ago. The last packet sent successfully to the server was
89,950,096 milliseconds ago. is longer than the server configured value of You sh
ould consider either expiring and/or testing connection validity before use in your application,

ncreasing the server configured values for client timeouts, or using the Connector/J connection pr
'autoReconnect=true' to avoid this problem.

'walt_timeout'.
.java:45)
at java.lang.reflect.Constructor.newInstance (Constructor.java:423)
at com. jdbc.Util.handleNewInstance (Util. java:404)
at jdbc.SQLError.createCommunicationsException (SQLError. java:981)
at jdbc.MysglIO.send (MysglIO. java:3652)
at Jjdbc.MysglIO.sglQueryDirect (MysglIO. java:2625)
at Jjdbc.
at Jjdbc.
at mysql. jdbc.
at com.mchange.v2.
:353)
at org.
at org.hibernate.
at org.
at org.
at
at
at
at
at
at
at

mysql.
com.mysqgl.
com.mysql.
mysql.
mysql.

.mysql.

com.
com.
com ConnectionImpl.execSQL (ConnectionImpl. java:2551)
PreparedStatement.executelInternal (PreparedStatement. java:1861)
PreparedStatement .executeQuery (PreparedStatement. java:1962)

c3p0.impl.NewProxyPreparedStatement .executeQuery (NewProxyPreparedStatement. j

com.mysql.

com.

hibernate.engine. jdbc.internal.ResultSetReturnImpl.extract (ResultSetReturnImpl. java:70)
getResultSet (Loader. java:2116)

executeQueryStatement (Loader. java:1899)

loader.Loader.

hibernate.loader.Loader.

hibernate.loader.Loader.executeQueryStatement (Loader. java:1875)

.doQuery (Loader. java:919)
Loader.doQueryAndInitializeNonLazyCollections (Loader. java:336)
doList (Loader.java:2611)

doList (Loader.java:2594)

listIgnoreQueryCache (Loader.java:2423)

list (Loader. java:2418)

criteria.Criterialoader.list (Criterialoader.java:109)

org.hibernate.loader.Loader

org.hibernate.loader.
org.
org.
org.
org.

org.hibernate.

hibernate.loader.Loader.

hibernate.loader.Loader.

hibernate.loader.Loader.

hibernate.loader.Loader.

loader.

at
at
at
at

org.
org.
.hibernate.

org

hibernate.
hibernate

internal.SessionImpl.list (SessionImpl.java:1774)

.internal.CriteriaImpl.list (CriteriaImpl. java:363)

internal.CriterialImpl.uniqueResult (CriteriaImpl. java:385)

eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.countByParamWithRestrict
ions (CdmEntityDaoBase. java:1197)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.IdentifiableDaoBase.countByTitleWithRestr

ictions (IdentifiableDaoBase. java:344)

at eu.etaxonomy.cdm.api.service.IdentifiableServiceBase.findByTitleWithRestrictions (Identifiab

leServiceBase.java:147)

sun.reflect.GeneratedMethodAccessorl89. invoke (Unknown Source)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:302)
odInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:157)

at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (
TransactionInterceptor. java:99)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransactio
n(TransactionAspectSupport. java:281)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterc
eptor.java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$SProxyl87.findByTitleWithRestrictions (Unknown Source)

at eu.etaxonomy.cdm.service.CdmFilterablePagingProvider.size (CdmFilterablePagingProvider. java:
182)

at org.vaadin.viritin.fields.LazyComboBox$7.size (LazyComboBox.java:261)

at org.vaadin.viritin.LazyList.size(LazyList.java:229)

at org.vaadin.viritin.ListContainer.size (ListContainer.java:368)

at com.vaadin.ui.ComboBox.getOptionsWithFilter (ComboBox.java:461)

at com.vaadin.ui.ComboBox.paintContent (ComboBox. java:261)

at com.vaadin.server.LegacyPaint.paint (LegacyPaint. java:65)

at com.vaadin.server.communication.LegacyUidlWriter.write (LegacyUidlWriter. java:82)

at com.vaadin.server.communication.UidlWriter.write (UidlWriter. java:143)

at com.vaadin.server.communication.UidlRequestHandler.writeUidl (UidlRequestHandler. java:124)

at com.vaadin.server.communication.UidlRequestHandler.synchronizedHandleRequest (UidlRequestHan
dler.java:92)

at com.vaadin.server.SynchronizedRequestHandler.handleRequest (SynchronizedRequestHandler. java:
41)

at com.vaadin.server.VaadinService.handleRequest (VaadinService.java:1435)

at com.vaadin.server.VaadinServlet.service (VaadinServlet. java:380)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder. java:808)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1669)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:316)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.invoke (FilterSe
curityInterceptor.java:126)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (Filter
SecurityInterceptor. java:90)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTransl
ationFilter.java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (SessionManagement
Filter.java:122)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.web.authentication.AnonymousAuthenticationFilter.doFilter (Anon
ymousAuthenticationFilter. java:111)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFilter.doFilte
r (SecurityContextHolderAwareRequestFilter. java:169)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (RequestCache
AwareFilter. java:48)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.Jjava:330)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.doFilterInter
nal (BasicAuthenticationFilter. java:158)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.oauth2.provider.authentication.OAuth2AuthenticationProcessingF
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr

security.web.FilterChainProxy.doFilterInternal (FilterChainProxy.java:21

security.web.FilterChainProxy.doFilter (FilterChainProxy. java:176)
web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterProxy. j

web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy. java:26

eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)

.web.filter.CharacterEncodingFilter.doFilterInternal (CharacterEncodingFi

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1652)
at org.eclipse.jetty.servlet.ServletHandler.doHandle (ServletHandler. java:585)
at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler.java:143)
at org.eclipse.jetty.security.SecurityHandler.handle (SecurityHandler. java:577)
at org.eclipse.jetty.server.session.SessionHandler.doHandle (SessionHandler. java:223)
at org.eclipse.jetty.server.handler.ContextHandler.doHandle (ContextHandler. java:1127)
at org.eclipse.jetty.servlet.ServletHandler.doScope (ServletHandler. java:515)
at org.eclipse.jetty.server.session.SessionHandler.doScope (SessionHandler. java:185)
at org.eclipse.jetty.server.handler.ContextHandler.doScope (ContextHandler. java:1061)
at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler. java:141)
at org.eclipse.jetty.server.handler.ContextHandlerCollection.handle (ContextHandlerCollection.j
ava:215)
at org.eclipse.jetty.server.handler.HandlerWrapper.handle (HandlerWrapper. java:97)
at org.eclipse.jetty.server.Server.handle (Server. java:497)
at org.eclipse.jetty.server.HttpChannel.handle (HttpChannel. java:310)
at org.eclipse.jetty.server.HttpConnection.onFillable (HttpConnection. java:257)
at org.eclipse. jetty.io.AbstractConnection$2.run (AbstractConnection. java:540)
at org.eclipse.jetty.util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635)
at org.eclipse.jetty.util.thread.QueuedThreadPool$3. run (QueuedThreadPool. java:555)
at java.lang.Thread.run (Thread. java:748)
Caused by: java.net.SocketException: Broken pipe (Write failed)
at java.net.SocketOutputStream.socketWriteO (Native Method)
at java.net.SocketOutputStream.socketWrite (SocketOutputStream. java:111)
at java.net.SocketOutputStream.write (SocketOutputStream. java:155)
at java.io.BufferedOutputStream.flushBuffer (BufferedOutputStream. java:82)
at java.io.BufferedOutputStream.flush (BufferedOutputStream. java:140)
at com.mysqgl. jdbc.MysqglIO.send (MysqlIO. java:3634)
107 more
Caused by:

java.net.SocketException:

Broken pipe

(Write failed)

at java.net.SocketOutputStream.socketWritel (Native Method)
at java.net.SocketOutputStream.socketWrite (SocketOutputStream. java:111)
at java.net.SocketOutputStream.write (SocketOutputStream. java:155)
at java.io.BufferedOutputStream.flushBuffer (BufferedOutputStream. java:82)

at java.io.BufferedOutputStream.flush (BufferedOutputStream. java:140)

at com.mysqgl. jdbc.MysqglIO.send (MysqglIO. java:3634)

at com.mysqgl. jdbc.MysqglIO.sendCommand (MysglIO. java:2460)

at com.mysqgl. jdbc.MysglIO.sglQueryDirect (MysglIO. java:2625)

at com.mysqgl. jdbc.ConnectionImpl.execSQL (ConnectionImpl. java:2551)

at com.mysqgl. jdbc.PreparedStatement .executelnternal (PreparedStatement. java:1861)

at com.mysqgl. jdbc.PreparedStatement.executeQuery (PreparedStatement.java:1962)

at com.mchange.v2.c3p0.impl.NewProxyPreparedStatement.executeQuery (NewProxyPreparedStatement. j
ava:353)

at org.hibernate.engine. jdbc.internal.ResultSetReturnImpl.extract (ResultSetReturnImpl. java:70)

at org.hibernate.loader.Loader.getResultSet (Loader. java:2116)

at org.hibernate.loader.Loader.executeQueryStatement (Loader. java:1899)

at org.hibernate.loader.Loader.executeQueryStatement (Loader. java:1875)

at org.hibernate.loader.Loader.doQuery (Loader.java:919)

at org.hibernate.loader.Loader.doQueryAndInitializeNonLazyCollections (Loader. java:336)

at org.hibernate.loader.Loader.dolList (Loader.java:2611)

at org.hibernate.loader.Loader.dolList (Loader.java:2594)

at org.hibernate.loader.Loader.listIgnoreQueryCache (Loader.java:2423)

at org.hibernate.loader.Loader.list (Loader.java:2418)

at org.hibernate.loader.criteria.Criterialoader.list (CriteriaLoader. java:109)

at org.hibernate.internal.SessionImpl.list (SessionImpl.java:1774)

at org.hibernate.internal.CriteriaImpl.list (CriteriaImpl. java:363)

at org.hibernate.internal.CriterialImpl.uniqueResult (CriteriaImpl. java:385)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.countByParamWithRestrict
ions (CdmEntityDaoBase.java:1197)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.IdentifiableDaoBase.countByTitleWithRestr
ictions (IdentifiableDaoBase.java:344)

at eu.etaxonomy.cdm.api.service.IdentifiableServiceBase.findByTitleWithRestrictions (Identifiab
leServiceBase.java:147)

at sun.reflect.GeneratedMethodAccessorl89.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMeth
odInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:157)

at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (
TransactionInterceptor. java:99)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransactio
n(TransactionAspectSupport. java:281)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterc
eptor.java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxyl87.findByTitleWithRestrictions (Unknown Source)

at eu.etaxonomy.cdm.service.CdmFilterablePagingProvider.size (CdmFilterablePagingProvider. java:
182)

at org.vaadin.viritin.fields.LazyComboBox$7.size (LazyComboBox. java:261)

at org.vaadin.viritin.LazyList.size (LazyList.java:229)

at org.vaadin.viritin.ListContainer.size (ListContainer.java:368)

at com.vaadin.ui.ComboBox.getOptionsWithFilter (ComboBox.java:461)

at com.vaadin.ui.ComboBox.paintContent (ComboBox. java:261)

at com.vaadin.server.LegacyPaint.paint (LegacyPaint.java:65)

at com.vaadin.server.communication.LegacyUidlWriter.write (LegacyUidlWriter. java:82)

at com.vaadin.server.communication.UidlWriter.write (UidlWriter. java:143)

at com.vaadin.server.communication.UidlRequestHandler.writeUidl (UidlRequestHandler. java:124)

at com.vaadin.server.communication.UidlRequestHandler.synchronizedHandleRequest (UidlRequestHan
dler.java:92)

at com.vaadin.server.SynchronizedRequestHandler.handleRequest (SynchronizedRequestHandler. java:
41)

at com.vaadin.server.VaadinService.handleRequest (VaadinService. java:1435)

at com.vaadin.server.VaadinServlet.service (VaadinServlet. java:380)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder. java:808)
at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1669)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:316)

at org.springframework.security.web

curityInterceptor.java:126)
at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (Filter
at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFilter.doFilte
r (SecurityContextHolderAwareRequestFilter. java:169)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (RequestCache
AwareFilter. java:48)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.doFilterInter
nal (BasicAuthenticationFilter. java:158)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.oauth2.provider.authentication.OAuth2AuthenticationProcessingF
ilter.doFilter (OAuth2AuthenticationProcessingFilter. java:176)
potentially related to #7106 ?

servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)
servlet.ServletHandler.doHandle (ServletHandler. java:585)
server.handler.ScopedHandler.handle (ScopedHandler. java:143)
security.SecurityHandler.handle (SecurityHandler. java:577)
server.session.SessionHandler.doHandle (SessionHandler. java:223)

server.handler.ContextHandler.doHandle (ContextHandler.java:1127)

servlet.ServletHandler.doScope (ServletHandler. java:515)

S(SIaVASS

server.
server.
server.

server

server.
SRV RIE o

S(SIaVASS

.session.

handler.
handler.
handler.

.handler.

SessionHandler.doScope (SessionHandler. java:185)
ContextHandler.doScope (ContextHandler. java:1061)
ScopedHandler.handle (ScopedHandler. java:141)
ContextHandlerCollection.handle (ContextHandlerCollection. j

HandlerWrapper.handle (HandlerWrapper. java:97)

Server.handle (Server. java:497)
HttpChannel.handle (HttpChannel. java:310)

.HttpConnection.onFillable (HttpConnection. java:257)

io.AbstractConnection$2.run (AbstractConnection. java:540)
util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635)
util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)
java.lang.Thread.run (Thread. java:748)

Related issues:

Related to EDIT - bug #7106: avoid factory.openSession() in CdmRepository Closed
Related to EDIT - bug #8170: javax.sql.DataSource.getConnection() implementat... New
Related to EDIT - bug #8171: javax.sql.DataSource.getConnection() implementa... Closed

Associated revisions

Revision d75¢4b91 - 03/06/2019 06:07 PM - Andreas Kohlbecker

ref #8132 c3p0 settings for debugging lost jdbc connections

Revision d2accd99 - 03/08/2019 02:21 PM - Andreas Kohlbecker

ref #8132 fixing problem of uncommited transaction in RegistrationWorkingsetPresenter

Revision 5479cc9a - 03/08/2019 02:26 PM - Andreas Kohlbecker

ref #8132 fixing problem of uncommited transaction in RegistrationWorkingsetPresenter

Revision 6f71379a - 03/11/2019 11:50 AM - Andreas Kohlbecker

ref #8132 proper transaction rollback in RegistrationWorkingsetPresenter

Revision 99583d95 - 03/11/2019 12:53 PM - Andreas Kohlbecker

ref #8132 proper transaction rollback in CdmStore

Revision 23025¢30 - 03/11/2019 02:01 PM - Andreas Kohlbecker

ref #8132 proper transaction rollback in RegistrationWorkingsetPresenter

Revision 278e8f96 - 03/11/2019 02:16 PM - Andreas Kohlbecker

ref #8132 proper transaction rollback in CdmStore

merging Conflicts in src/main/java/eu/etaxonomy/cdm/service/CdmStore.java

Revision 5261131c - 03/11/2019 06:10 PM - Andreas Kohlbecker

ref #8132 proper transaction rollback in CdmStore - copied from hfx branch

Revision 98db0610 - 03/12/2019 12:52 PM - Andreas Kohlbecker

ref #8132 fixin bug related to transaction rollback in CdmStore

History
https://dev.e-taxonomy.eu/redmine/issues/7106

#4 - 02/25/2019 01:06 PM - Andreas Kohlbecker

these connectivity problems should be prevented by c3p0 since the idleConnectionTestPeriod is set to 600 (10 minutes)

#5 - 02/25/2019 03:21 PM - Andreas Kohlbecker

| added autoReconnect=true to the connection string of the phycobank datasource.

#6 - 02/25/2019 03:48 PM - Andreas Kohlbecker

Andreas Kohlbecker wrote:

| added autoReconnect=true to the connection string of the phycobank datasource.

using this parameter is highly discouraged:

"If enabled the driver will throw an exception for a queries issued on a stale or dead connection, which belong to the current transaction,
but will attempt reconnect before the next query issued on the connection in a new transaction. The use of this feature is not recommended,
because it has side effects related to session state and data consistency when applications do not handle SQLExceptions properly, and is only
designed to be used when you are unable to configure your application to handle SQLExceptions resulting from dead and stale connections properly.
Alternatively, investigate setting the MySQL server variable "wait_timeout" to some high value rather than the default of 8 hours." (
https://stackoverflow.com/questions/667289/why-does-autoreconnect-true-not-seem-to-work)

#7 - 02/27/2019 03:35 PM - Andreas Kohlbecker

- File cdmserver-docker-c3p0-connectivityproblem.png added

#9 - 02/27/2019 03:52 PM - Andreas Kohlbecker

| set testConnectionsOnChecklIn=true temporarily via jmx in order to test if this helps avoiding this connectivity problem.
#10 - 03/01/2019 01:58 PM - Andreas Kohlbecker
Andreas Kohlbecker wrote:

| set testConnectionsOnCheckIn=true temporarily via jmx in order to test if this helps avoiding this connectivity problem.

this did not really help, so | added this configuration option now to the system environment:
-Dc3p0.testConnectionOnCheckout=true

Further more | try logging the com.mchange.v2.c3p0.impl.DefaultConnectionTester by adding
log4j.logger.com.mchange.v2.c3p0.impl.DefaultConnectionTester=DEBUG
to the log4j.properties but there is no logging visible from this class.

#11 - 03/01/2019 02:46 PM - Andreas Kohlbecker

this here https://stackoverflow.com/questions/34408362/c3p0-connection-pool-gives-connection-timeout-error-with-this-configuration#34409748
seems to be related!

#12 - 03/01/2019 04:05 PM - Andreas Kohlbecker

It seems as if this problem is being cased by the CdmPFilterablePagingProvider which might open an new Sesscion which is not being closed
afterwards. SO the connection stays open until the mysql will time it out.
This hypothesis needs to be confirmed.

Meanwhile | will set the configuration options unreturnedConnectionTimeout=3600 (1h) and debugUnreturnedConnectionStackTraces=true to debug
the situation and to prevent from errors in the application.

#13 - 03/05/2019 05:11 PM - Andreas Kohlbecker
- Subject changed from phycobank docker container problems with db connections to phycobank cdm-server instance problems with db connections

- Description updated

#14 - 03/05/2019 05:22 PM - Andreas Kohlbecker

Results from the server log:

The problem occurred again. The jdbc connection which was being used by the tread qtp1207140081-33 was causing problems. This thread has

been used before by the taxeditor and finally cdm-vaadin when the first stacktrace was logged. Later on the "broken" connection is being used in the
context of another thread qtp1207140081-35
before

[phycobank] 2019-03-05 11:04:24,453 DEBUG [gtpl207140081-33] [org.springframework.remoting.support.RemotelInvoc
ationTraceInterceptor] - Incoming HttpInvokerServiceExporter remote call: eu.etaxonomy.cdm.api.service.IIdenti
fiableEntityService.findByTitle
[phycobank] 2019-03-05 11:04:24

[phycobank] 2019-03-05 11:04:24,453 DEBUG [gtpl207140081-33] [org.springframework.remoting.support.RemotelInvoc
ationTraceInterceptor] - Incoming HttpInvokerServiceExporter remote call: eu.etaxonomy.cdm.api.service.IIdenti
fiableEntityService.findByTitle
[phycobank] 2019-03-05 11:04:24

[phycobank] 2019-03-05 11:04:24,453 DEBUG [gtpl207140081-33] [org.springframework.remoting.support.Remotelnvoc
ationTraceInterceptor] - Incoming HttpInvokerServiceExporter remote call: eu.etaxonomy.cdm.api.service.IIdenti
fiableEntityService.findByTitle
[phycobank] 2019-03-05 11:04:24

[phycobank] 2019-03-05 11:04:24,453 DEBUG [gtpl207140081-33] [org.springframework.remoting.support.RemotelInvoc
ationTraceInterceptor] - Incoming HttpInvokerServiceExporter remote call: eu.etaxonomy.cdm.api.service.IIdenti
fiableEntityService.findByTitle
[phycobank] 2019-03-05 11:04:24

ERROR

[phycobank] 2019-03-05 11:50:07,891 DEBUG [gtpl207140081-33] [com.mchange.v2.c3p0.impl.DefaultConnectionTester
] - Testing a Connection in response to an Exception:
com.mysqgl. jdbc.exceptions. jdbc4.MySQLNonTransientConnectionException: No operations allowed after connection c
losed.

at sun.reflect.NativeConstructorAccessorImpl.newInstance0O (Native Method)

at sun.reflect.NativeConstructorAccessorImpl.newInstance (NativeConstructorAccessorImpl. java:62)

at sun.reflect.DelegatingConstructorAccessorImpl.newInstance (DelegatingConstructorAccessorImpl.java:45

at java.lang.reflect.Constructor.newInstance (Constructor. java:423)

at com.mysgl. jdbc.Util.handleNewInstance (Util. java:404)

at com.mysqgl.jdbc.Util.getInstance (Util.java:387)

at com.mysgl.jdbc.SQLError.createSQLException (SQLError. java:917)

at com.mysqgl. jdbc.SQLError.createSQLException (SQLError. java:896)

at com.mysqgl. jdbc.SQLError.createSQLException (SQLError. java:885)

at com.mysgl. jdbc.SQLError.createSQLException (SQLError. java:860)

at com.mysqgl. jdbc.ConnectionImpl.throwConnectionClosedException (ConnectionImpl. java:1235)
at com.mysqgl. jdbc.ConnectionImpl.checkClosed (ConnectionImpl. java:1230)

at org.hibernate.loader.criteria.Criterialoader.list (CriteriaLoader.java:109)

at org.hibernate.internal.SessionImpl.list (SessionImpl.java:1774)

at org.hibernate.internal.CriteriaImpl.list (CriteriaImpl. java:363)

at org.hibernate.internal.CriterialImpl.uniqueResult (CriteriaImpl. java:385)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.countByParam (CdmEntityDaoBase. ja
va:1113)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.countByParam(VersionableDaoBas
e.java:388)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.IdentifiableDaoBase.countByTitle (IdentifiableDaoB
ase.java:334)

at eu.etaxonomy.cdm.api.service.IdentifiableServiceBase.findByTitle (IdentifiableServiceBase. java:134)

at com.sun.proxy.S$Proxyl96.findByTitle (Unknown Source)

at eu.etaxonomy.cdm.service.CdmFilterablePagingProvider.size (CdmFilterablePagingProvider.java:193)

at org.vaadin.viritin.fields.LazyComboBox$4.size (LazyComboBox. java:142)

at org.vaadin.viritin.LazyList.size (LazyList.Jjava:229)

at java.util.AbstractCollection.isEmpty (AbstractCollection. java:86)

at org.vaadin.viritin.ListContainer.firstItemId(ListContainer.java:185)

at org.vaadin.viritin.fields.TypedSelect.getType (TypedSelect.java:339)

at org.vaadin.viritin.fields.LazyComboBox.loadFrom(LazyComboBox. java:264)

at eu.etaxonomy.vaadin.component.ToOneRelatedEntityCombobox.loadFrom(ToOneRelatedEntityCombobox. java:l
18)

at eu.etaxonomy.cdm.vaadin.view.reference.ReferenceEditorPresenter.updateInReferencePageProvider (Refer
enceEditorPresenter.java:142)

at eu.etaxonomy.cdm.vaadin.view.reference.ReferenceEditorPresenter.handleViewEntered (ReferenceEditorPr
esenter. java:86)

at eu.etaxonomy.vaadin.mvp.AbstractPresenter.onViewEnter (AbstractPresenter. java:158)

at eu.etaxonomy.vaadin.mvp.AbstractPopupView.viewEntered (AbstractPopupView. java:95)

at eu.etaxonomy.vaadin.ui.navigation.NavigationManagerBean.showInPopup (NavigationManagerBean. java:181)

at eu.etaxonomy.vaadin.mvp.AbstractPresenter.openPopupEditor (AbstractPresenter.java:237)

at eu.etaxonomy.cdm.vaadin.view.name.TaxonNameEditorPresenter.onReferenceEditorActionAdd (TaxonNameEdit
orPresenter. java:340)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
ing.events.internal.MethodListenerWrapper.publish (MethodListenerWrapper.java:78)
ing.events.internal.ListenerCollection.publish (ListenerCollection.java:167)
ing.events.internal.ScopedEventBus.publish (ScopedEventBus.java:116)

ing.events.internal.ScopedEventBus.publish (ScopedEventBus. java:109)
eu.etaxonomy.cdm.vaadin.view.name.TaxonNamePopupEditor.lambda$initContent$61446b05$1 (TaxonNamePopup
Editor.java:328)
at sun.reflect.GeneratedMethodAccessor624.invoke (Unknown Source)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)

event .ListenerMethod.receiveEvent (ListenerMethod. java:510)

event .EventRouter.fireEvent (EventRouter. java:200)

event .EventRouter.fireEvent (EventRouter. java:163)
server.AbstractClientConnector.fireEvent (AbstractClientConnector. java:1015)

.ui.Button.fireClick (Button.java:377)

ui.Button$l.click (Button. java:54)
reflect.GeneratedMethodAccessor627.invoke (Unknown Source)

.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)

com.vaadin.server.ServerRpcManager.applyInvocation (ServerRpcManager. java:158)
e.je
e.je
tty.server.Server.handle (Server.java:497)
tty.server.HttpChannel.handle (HttpChannel. java:310)
tty.server.HttpConnection.onFillable (HttpConnection. java:257)
tty.io.AbstractConnection$2.run (AbstractConnection. java:540)
tty.util.thread.QueuedThreadPool.rundob (QueuedThreadPool. java:635)
tty.util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)
java.lang.Thread.run (Thread. java:748)

2019-03-05 11:50:07,900 WARN [gtpl207140081-33] [org.hibernate.engine.jdbc.spi.SqglExceptionHelper]
0, SQLState: 08003
2019-03-05 11:50:07,905 ERROR [gtpl1207140081-33] [org.hibernate.engine.jdbc.spi.SqglExceptionHelper
] - No operations allowed after connection closed.

2019-03-05 11:50:07,911 DEBUG [qgtpl207140081-33] [com.mchange.v2.c3p0.impl.DefaultConnectionTester
] - Testing a Connection in response to an Exception:

com.mysqgl. jdbc.exceptions. jdbc4.MySQLNonTransientConnectionException: No operations allowed after connection c

losed.
Util.handleNewInstance (Util.java:404)

Util.getInstance (Util. java:387)

SQLError.createSQLException (SQLError.java:917)
SQLError.createSQLException (SQLError. java:896)
SQLError.createSQLException (SQLError. java:885)
SQLError.createSQLException (SQLError. java:860)
ConnectionImpl.throwConnectionClosedException (ConnectionImpl. java:1235)
ConnectionImpl.checkClosed (ConnectionImpl. java:1230)
ConnectionImpl.prepareStatement (ConnectionImpl. java:4132)
ConnectionImpl.prepareStatement (ConnectionImpl. java:4101)
c3p0.impl.NewProxyConnection.prepareStatement (NewProxyConnection. java:567)

.hibernate.engine. jdbc.internal.StatementPreparerImpl$5.doPrepare (StatementPreparerImpl. java:146

.hibernate.engine.jdbc.internal.StatementPreparerImpl$StatementPreparationTemplate.prepareStatem

ent (StatementPreparerImpl.java:172)
.executeQueryStatement (Loader. java:1897)
loader.Loader.

loader.Loader

loader.Loader.
loader.Loader.
loader.Loader.
loader.Loader.
loader.Loader.
jdbc.internal.StatementPreparerImpl.prepareQueryStatement (StatementPreparerImp

prepareQueryStatement (Loader. java:1928)

executeQueryStatement (Loader.java:1875)

doQuery (Loader. java:919)
doQueryAndInitializeNonLazyCollections (Loader.java:336)
doList (Loader.java:2611)

doList (Loader. java:2594)
listIgnoreQueryCache (Loader. java:2423)

list (Loader.java:2418)

loader.criteria.Criterialoader.list (CriteriaLoader.java:109)

.internal.SessionImpl.list (SessionImpl. java:1774)

internal.CriteriaImpl.list (CriteriaImpl.java:363)

internal.CriteriaImpl.uniqueResult (CriterialImpl. java:385)
eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.countByParam (CdmEntityDaoBase. ja

912



at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.countByParam(VersionableDaoBas
e.java:388)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.IdentifiableDaoBase.countByTitle (IdentifiableDaoB
ase.java:334)

at eu.etaxonomy.cdm.api.service.IdentifiableServiceBase.findByTitle (IdentifiableServiceBase. java:134)

at org.eclipse. jetty.util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635)

at org.eclipse.jetty.util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)

at java.lang.Thread.run (Thread. java:748)
[phycobank] 2019-03-05 11:50:07,913 WARN [gtpl207140081-33] [com.mchange.v2.c3p0.impl.NewPooledConnection] - [
c3p0] A PooledConnection that has already signalled a Connection error is still in use!
[phycobank] 2019-03-05 11:50:07,913 WARN [gtpl207140081-33] [com.mchange.v2.c3p0.impl.NewPooledConnection] - [
c3p0] Another error has occurred [ com.mysqgl.jdbc.exceptions. jdbc4.MySQLNonTransientConnectionException: No op
erations allowed after connection closed. ] which will not be reported to listeners!
com.mysqgl. jdbc.exceptions. jdbc4.MySQLNonTransientConnectionException: No operations allowed after connection c
losed.

at sun.reflect.NativeConstructorAccessorImpl.newInstance0 (Native Method)

the connection which is closed reoports: SQL Error: 0, SQLState: 08003

#16 - 03/06/2019 05:46 PM - Andreas Kohlbecker

- Description updated

#17 - 03/06/2019 05:46 PM - Andreas Kohlbecker
- Related to bug #7106: avoid factory.openSession() in CdmRepository added

#18 - 03/07/2019 12:37 PM - Andreas Kohlbecker

The problem just occurred again. This time no one was using the Taxeditor since the instance has been started.
The ¢3p0 jmx bean reports
numUnclosedOrphanedConnections=1

There is a good change that these problems are caused by unintentionally opening new unmanaged sessions, see #7106

#19 - 03/08/2019 02:02 PM - Andreas Kohlbecker

debugging the cdm-server to find connections that have been opened but which are not being closed properly (DebugC3P0Connections) revealed
that the problem is caused in situations when eu.etaxonomy.cdm.api.application.CdmRepository.startTransaction(CdmRepository.java:460) is being
used in turn of RegistrationWorkingsetPresenter.onEntityChangeEvent(RegistrationWorkingsetPresenter.java:760)

[phycobank] 12:05:05,721 INFO [C3P0OPooledConnectionPoolManager[identityToken->z8kfsxalpsn7sp6adpb9|£f2f2ccl]-Ad
minTaskTimer] [co.mc.v2.re.BasicResourcePool] - Logging the stack trace by which the overdue resource was check
ed-out.
java.lang.Exception: DEBUG STACK TRACE: Overdue resource check-out stack trace.

at com.mchange.v2.resourcepool.BasicResourcePool.checkoutResource (BasicResourcePool. java:588)

at com.mchange.v2.c3p0.impl.C3P0PooledConnectionPool.checkoutAndMarkConnectionInUse (C3P0PooledConnecti
onPool. java:758)

at com.mchange.v2.c3p0.impl.C3P0PooledConnectionPool.checkoutPooledConnection (C3P0PooledConnectionPool
.java:685)

at com.mchange.v2.c3p0.impl.AbstractPoolBackedDataSource.getConnection (AbstractPoolBackedDataSource. ja
va:140)

at org.hibernate.engine. jdbc.connections.internal.DatasourceConnectionProviderImpl.getConnection (Datas
ourceConnectionProviderImpl. java:122)

at org.hibernate.internal.AbstractSessionImpl$NonContextualJdbcConnectionAccess.obtainConnection (Abstr
actSessionImpl. java:386)

at org.hibernate.resource. jdbc.internal.LogicalConnectionManagedImpl.acquireConnectionIfNeeded (Logical
ConnectionManagedImpl. java:87)

at org.hibernate.resource. jdbc.internal.LogicalConnectionManagedImpl.getPhysicalConnection (LogicalConn
ectionManagedImpl. java:112)

at org.hibernate.resource. jdbc.internal.LogicalConnectionManagedImpl.getConnectionForTransactionManage
ment (LogicalConnectionManagedImpl. java:230)

at org.hibernate.resource. jdbc.internal.LogicalConnectionManagedImpl.begin (LogicalConnectionManagedImp
1.java:237)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTransactionCoordinatorImp
l1$TransactionDriverControlImpl.begin (JdbcResourceLocalTransactionCoordinatorImpl. java:214)

at org.hibernate.engine.transaction.internal.TransactionImpl.begin(TransactionImpl. java:52)

at org.hibernate.internal.SessionImpl.beginTransaction (SessionImpl. java:1512)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doBegin (HibernateTransactionManager.
java:499)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction (AbstractP
latformTransactionManager. java:373)

at eu.etaxonomy.cdm.api.application.CdmRepository.startTransaction (CdmRepository.java:460)

at eu.etaxonomy.cdm.api.application.CdmRepository.startTransaction (CdmRepository.java:436)

at eu.etaxonomy.cdm.vaadin.view.registration.RegistrationWorkingsetPresenter.onEntityChangeEvent (Regis
trationWorkingsetPresenter. java:760)

#20 - 03/08/2019 05:17 PM - Andreas Kohlbecker
Another situation in which a connection is being opened but not properly closed is occurring in the DataSourceConfigurer.dataSource() method:
14:40:29,148 INFO [C3POPooledConnectionPoolManager [identityToken—->z8kfsxalpy9c3gluw8b66|6b756a62]-AdminTaskTim
er] [co.mc.v2.re.BasicResourcePool] - Logging the stack trace by which the overdue resource was checked-out.
java.lang.Exception: DEBUG STACK TRACE: Overdue resource check-out stack trace.

at com.mchange.v2.resourcepool.BasicResourcePool.checkoutResource (BasicResourcePool. java:588)

at com.mchange.v2.c3p0.impl.C3P0PooledConnectionPool.checkoutAndMarkConnectionInUse (C3P0PooledConnectionPo
ol.java:758)

at com.mchange.v2.c3p0.impl.C3P0PooledConnectionPool.checkoutPooledConnection (C3P0PooledConnectionPool. jav
a:685)

at com.mchange.v2.c3p0.impl.AbstractPoolBackedDataSource.getConnection (AbstractPoolBackedDataSource. java:l
40)

at eu.etaxonomy.cdm.database.WrappedCdmDataSource.getConnection (WrappedCdmDataSource. java:66)

at eu.etaxonomy.cdm.database.WrappedCdmDataSource.executeQuery (WrappedCdmDataSource. java:360)

at eu.etaxonomy.cdm.database.WrappedCdmDataSource.getSingleValue (WrappedCdmDataSource. java:393)

at eu.etaxonomy.cdm.database.update.SchemaUpdaterBase.getCurrentVersion (SchemaUpdaterBase. java:82)

at eu.etaxonomy.cdm.database.update.UpdaterBase.isToBeInvoked (UpdaterBase.java:72)

at eu.etaxonomy.cdm.database.update.UpdaterBase.countSteps (UpdaterBase. java:55)

at eu.etaxonomy.cdm.database.update.CdmUpdater.updateToCurrentVersion (CdmUpdater. java:94)

at eu.etaxonomy.cdm.opt.config.DataSourceConfigurer.dataSource (DataSourceConfigurer. java:251)

The actual problem, however, comes from the eu.etaxonomy.cdm.database.WrappedCdmDataSource which implements
javax.sql.DataSource.getConnection() in a false and dangerous way: #8170, #8171

#21 - 03/08/2019 05:18 PM - Andreas Kohlbecker

- Related to bug #8170: javax.sql.DataSource.getConnection() implementation in WrappedCdmDataSource does not conform to the interface added
#22 - 03/08/2019 05:18 PM - Andreas Kohlbecker

- Related to bug #8171: javax.sql.DataSource.getConnection() implementation in WrappedCdmDataSource fails to cache the connection which and
leaves it unclosed added

#23 - 04/11/2019 05:38 PM - Andreas Kohlbecker

- Target version changed from Release 5.6 to Release 5.7

#24 - 05/03/2019 02:59 PM - Andreas Miiller

- Target version changed from Release 5.7 to Release 5.8

#25 - 07/19/2019 03:07 PM - Andreas Kohlbecker

- Target version changed from Release 5.8 to Release 5.10

#26 - 09/20/2019 05:37 PM - Andreas Kohlbecker

- Target version changed from Release 5.10 to Release 5.11

#27 - 11/04/2019 04:36 PM - Andreas Kohlbecker

- Target version changed from Release 5.11 to Release 5.12

#28 - 01/16/2020 11:51 AM - Andreas Kohlbecker

- Target version changed from Release 5.12 to Release 5.13

#29 - 03/10/2020 09:28 AM - Andreas Kohlbecker

- Target version changed from Release 5.13 to Release 5.14

#30 - 04/08/2020 04:13 PM - Andreas Miiller

- Target version changed from Release 5.14 to Release 5.15

#31 - 06/23/2020 01:58 PM - Andreas Miiller
- Target version changed from Release 5.15 to Release 5.18

#32 - 12/01/2020 03:08 PM - Andreas Kohlbecker

- Target version changed from Release 5.18 to Release 5.19

#33 - 01/27/2021 03:13 PM - Andreas Kohlbecker

- Target version changed from Release 5.19 to Release 5.21

#34 - 03/10/2021 02:53 PM - Andreas Miiller

- Target version changed from Release 5.21 to Release 5.22

#35 - 04/19/2021 04:35 PM - Andreas Kohlbecker

- Target version changed from Release 5.22 to Release 5.46

#36 - 02/22/2022 01:27 PM - Andreas Miiller

- Status changed from New to In Progress

This ticket seems at least to be in progress. Is it still open at all?

#37 - 12/01/2022 06:53 PM - Andreas Miiller
- Status changed from In Progress to Resolved
- Assignee changed from Andreas Kohlbecker to Wolf-Henning Kusber

- Target version changed from Release 5.46 to Release 5.35

To me it seems that this problem did not occur anymore in the last years and we can close the ticket as worksforme.

Henning, can you please verify?

#38 - 12/02/2022 02:47 PM - Andreas Miiller
- Status changed from Resolved to Worksforme

- Target version deleted (Release 5.35)
